*Transport-agnostic operation-rich client-server JSON synchronization protocol.*

# Pros

- [Operational Transformations][] minimizes the number of UI operations at the
  cost of tremendous implementation complexity that rises exponentially with the
  number of operations it supports.
- [CRDTs][] tend to use a lot of memory, and require tricky garbage collection to
  avoid bloat. Canop does not suffer from memory bloat. Canonical operations are
  immutable, and so, can be substituted for the equivalent string. CRDTs are,
  however, ideal for peer-to-peer synchronization.
- [Rebase-sync][] requires local changes to be rebased by changes that the
  server has accepted, similar to our design. However, it denies changes that
  are not rebased, causing the potential for long-term divergence if changes
  happen faster than a client-server round-trip. Canop operations are
  immediately rebased and accepted by the server.

[Operational Transformations]: http://lively-kernel.org/repository/webwerkstatt/projects/Collaboration/paper/Jupiter.pdf
[CRDTs]: http://arxiv.org/pdf/0907.0929.pdf
[Rebase-sync]: http://marijnhaverbeke.nl/blog/collaborative-editing.html

# Cons

Out of the box, Canop does not support peer-to-peer editing. It would require
adding a consensus algorithm to determine the form of canonical operations.
